"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = colorContinuous;

var _d3Scale = require("d3-scale");

var _palette = _interopRequireWildcard(require("./palette"));

var _utils = require("./utils");

function colorContinuous(_ref) {
  var attr = _ref.attr,
      domain = _ref.domain,
      _ref$colors = _ref.colors,
      colors = _ref$colors === void 0 ? _palette.DEFAULT_PALETTE : _ref$colors,
      _ref$nullColor = _ref.nullColor,
      nullColor = _ref$nullColor === void 0 ? _palette.NULL_COLOR : _ref$nullColor;
  (0, _utils.assert)(Array.isArray(domain), 'Expected "domain" to be an array of numbers');
  var palette = typeof colors === 'string' ? (0, _palette["default"])(colors) : colors;
  var color = (0, _d3Scale.scaleLinear)().domain(domain).range(palette);
  return function (d) {
    var value = (0, _utils.getAttrValue)(attr, d);
    return Number.isFinite(value) ? color(value) : nullColor;
  };
}
//# sourceMappingURL=color-continuous-style.js.map