"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getAttrValue = getAttrValue;
exports.assert = assert;

var _typeof2 = _interopRequireDefault(require("@babel/runtime/helpers/typeof"));

var ALLOWED_ATTR_TYPES = Object.freeze(['function', 'string']);

function getAttrValue(attr, d) {
  assert((0, _typeof2["default"])(d) === 'object', 'Expected "data" to be an object');
  assert(ALLOWED_ATTR_TYPES.includes((0, _typeof2["default"])(attr)), 'Expected "attr" to be a function or string');

  if ((0, _typeof2["default"])(attr) === ALLOWED_ATTR_TYPES[0]) {
    return attr(d);
  }

  if ((0, _typeof2["default"])(attr) === ALLOWED_ATTR_TYPES[1]) {
    return d.properties[attr];
  }

  return {};
}

function assert(condition) {
  var message = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (!condition) {
    throw new Error("CARTO style error: ".concat(message));
  }
}
//# sourceMappingURL=utils.js.map