import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import _regeneratorRuntime from "@babel/runtime/regenerator";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";
import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _get from "@babel/runtime/helpers/esm/get";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import { CompositeLayer } from '@deck.gl/core';
import { MVTLayer } from '@deck.gl/geo-layers';

var defaultProps = _objectSpread(_objectSpread({}, MVTLayer.defaultProps), {}, {
  data: null,
  credentials: null,
  onDataLoad: {
    type: 'function',
    value: function value(tilejson) {},
    compare: false
  },
  onDataError: {
    type: 'function',
    value: null,
    compare: false,
    optional: true
  }
});

var CartoLayer = function (_CompositeLayer) {
  _inherits(CartoLayer, _CompositeLayer);

  var _super = _createSuper(CartoLayer);

  function CartoLayer() {
    _classCallCheck(this, CartoLayer);

    return _super.apply(this, arguments);
  }

  _createClass(CartoLayer, [{
    key: "initializeState",
    value: function initializeState() {
      this.state = {
        tilejson: null
      };
    }
  }, {
    key: "updateState",
    value: function updateState(_ref) {
      var changeFlags = _ref.changeFlags;
      var data = this.props.data;

      if (changeFlags.dataChanged && data) {
        this._updateData();
      }
    }
  }, {
    key: "_updateData",
    value: function () {
      var _updateData2 = _asyncToGenerator(_regeneratorRuntime.mark(function _callee() {
        var tilejson;
        return _regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                _context.prev = 0;
                _context.next = 3;
                return this.updateTileJSON();

              case 3:
                tilejson = _context.sent;
                this.setState({
                  tilejson: tilejson
                });
                this.props.onDataLoad(tilejson);
                _context.next = 15;
                break;

              case 8:
                _context.prev = 8;
                _context.t0 = _context["catch"](0);

                if (!this.props.onDataError) {
                  _context.next = 14;
                  break;
                }

                this.props.onDataError(_context.t0);
                _context.next = 15;
                break;

              case 14:
                throw _context.t0;

              case 15:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this, [[0, 8]]);
      }));

      function _updateData() {
        return _updateData2.apply(this, arguments);
      }

      return _updateData;
    }()
  }, {
    key: "updateTileJSON",
    value: function () {
      var _updateTileJSON = _asyncToGenerator(_regeneratorRuntime.mark(function _callee2() {
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                throw new Error('You must use one of the specific carto layers: BQ or SQL type');

              case 1:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      function updateTileJSON() {
        return _updateTileJSON.apply(this, arguments);
      }

      return updateTileJSON;
    }()
  }, {
    key: "onHover",
    value: function onHover(info, pickingEvent) {
      var _this$getSubLayers = this.getSubLayers(),
          _this$getSubLayers2 = _slicedToArray(_this$getSubLayers, 1),
          mvtLayer = _this$getSubLayers2[0];

      return mvtLayer ? mvtLayer.onHover(info, pickingEvent) : _get(_getPrototypeOf(CartoLayer.prototype), "onHover", this).call(this, info, pickingEvent);
    }
  }, {
    key: "renderLayers",
    value: function renderLayers() {
      if (!this.state.tilejson) return null;
      var updateTriggers = this.props.updateTriggers;
      return new MVTLayer(this.props, this.getSubLayerProps({
        id: 'mvt',
        data: this.state.tilejson,
        updateTriggers: updateTriggers
      }));
    }
  }, {
    key: "isLoaded",
    get: function get() {
      return this.getSubLayers().length > 0 && _get(_getPrototypeOf(CartoLayer.prototype), "isLoaded", this);
    }
  }]);

  return CartoLayer;
}(CompositeLayer);

export { CartoLayer as default };
CartoLayer.layerName = 'CartoLayer';
CartoLayer.defaultProps = defaultProps;
//# sourceMappingURL=carto-layer.js.map