import { scaleLinear } from 'd3-scale';
import getPalette, { DEFAULT_PALETTE, NULL_COLOR } from './palette';
import { assert, getAttrValue } from './utils';
export default function colorContinuous(_ref) {
  var attr = _ref.attr,
      domain = _ref.domain,
      _ref$colors = _ref.colors,
      colors = _ref$colors === void 0 ? DEFAULT_PALETTE : _ref$colors,
      _ref$nullColor = _ref.nullColor,
      nullColor = _ref$nullColor === void 0 ? NULL_COLOR : _ref$nullColor;
  assert(Array.isArray(domain), 'Expected "domain" to be an array of numbers');
  var palette = typeof colors === 'string' ? getPalette(colors) : colors;
  var color = scaleLinear().domain(domain).range(palette);
  return function (d) {
    var value = getAttrValue(attr, d);
    return Number.isFinite(value) ? color(value) : nullColor;
  };
}
//# sourceMappingURL=color-continuous-style.js.map